#include "userbase.h"

#define MAX_REPLIES 1000

char* postnet_download::Goto (int p)
{
	int i, t;

	if (cache.n < p) {
		i = cache.d;
		t = p - cache.n;
	} else {
		i = 0;
		t = p;
	}

	if (t == 0) return &data [i];
	for (; i < dlen; i++)
		if (data [i] == 0)
		if (--t == 0) {
			cache.n = p;
			return &data [cache.d = i + 1];
		}
	return NULL;
}

bool postnet_download::getreply (i_argstream &I, o_argstream &O)
{
	char prl [MAX_PRL], rl [MAX_MAX];
	char *tags [] = { "title=", "author=", "date=", "crc=" };
	int lens [] = { MAX_TITLE, MAX_AUTHOR, MAX_DATE, MAX_CRC };
	char t [MAX_TITLE], a [MAX_AUTHOR], d [MAX_DATE], c [MAX_CRC];
	char *rets [] = { t, a, d, c };

	t [0] = a [0] = d [0] = c [0] = prl [0] = 0;
	for (;;) {
		if (I.getarg (rl, MAX_MAX) != GETARG_OK) return false;
		if (!rl [0]) break;
		if (!prl [0]) {
			Strncpy (prl, rl, MAX_PRL);
			continue;
		}
		tagparse (rl, tags, lens, rets, 4);
	}

	if (!prl[0] || !t[0] || !a[0] || !d[0] || !c[0]) return false;

	O.putarg (prl);
	O.putarg (t);
	O.putarg (a);
	O.putarg (d);
	O.putarg (c);

	return true;
}

postnet_download::postnet_download (char *p, char *par)
{
	char to [MAX_PRL], msg [MAX_MSGID], author [MAX_AUTHOR];
	char ty [16], *c;
	struct {
		char title [MAX_TITLE], parent [MAX_PRL];
	} DH; 
	i_argstream I;
	char oas [40];
	o_argstream O (oas, sizeof oas);
	int nr;

	Author = ThisPRL = Title = Parent = data = NULL;

	success = PD_ER;
	if (!goodPRL (p)) return;

	CPofPRL (p, to);
	strcpy (msg, MsgIDofPRL (p));

	success = PD_OF;
	if (!contact (to, I, author, nr)) return;
DPRINTF (DB_SLOT2, "++++Contacted[%s]\n", to);

	/* PROTOCOL-STUFF-LOCATION */
	O.putarg (Globals.PMSGtext [DOWNLOAD]);
	O.putarg (msg);
	O.writeout (I.fd);

	if (I.getarg (ty, 10) != GETARG_OK) goto pd_fail;

	success = PD_NA;
	if (PMSGtype (ty) != PNET_OK) goto pd_fail;

	success = PD_PE;
	if (I.getarg (DH.title, MAX_TITLE) != GETARG_OK
	|| I.getarg (DH.parent, MAX_PRL) != GETARG_OK
	|| I.getarg (ty, 15) != GETARG_OK
	|| (nr = ahtoi (ty)) > MAX_REPLIES) {
pd_fail:
		close (I.fd);
		return;
	}

	c = (char*) alloca (nr * (MAX_MAX));
	o_argstream Array (c, nr * (MAX_MAX));

	replies = nr;
	while (nr--)
		if (!getreply (I, Array)) goto pd_fail2;

	Author = StrDup (author);
	ThisPRL = StrDup (p);
	Title = StrDup (DH.title);
	Parent = StrDup (DH.parent);
	data = new char [dlen = Array.have];
	memcpy (data, c, dlen);

	cache.d = cache.n = 0;

	success = PD_OK;
	if (par && strcasecmp (par, Parent)) success = PD_FU;

pd_fail2:
	close (I.fd);
}

postnet_download::~postnet_download ()
{
	if (Author)	delete [] Author;
	if (ThisPRL)	delete [] ThisPRL;
	if (Title)	delete [] Title;
	if (Parent)	delete [] Parent;
	if (data)	delete [] data;
}

char *postnet_download::nPRL (int n)
{
	return Goto (n * 5);
}

char *postnet_download::nTitle (int n)
{
	return Goto (n * 5 + 1);
}

char *postnet_download::nAuthor (int n)
{
	return Goto (n * 5 + 2);
}

char *postnet_download::nDate (int n)
{
	return Goto (n * 5 + 3);
}

char *postnet_download::nCRC (int n)
{
	return Goto (n * 5 + 4);
}

////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////

static char textplain [] = "text/plain";
static char unknown [] = "application/octet-stream";

postnet_get::postnet_get (char *p, bool getcontent, unsigned long crc)
{
	char b [40], to [MAX_PRL], author [MAX_AUTHOR], dateb [MAX_DATE];
	i_argstream I;
	char oas [40];
	o_argstream O (oas, sizeof oas);
	int i;

	rep = -1;
	content = date = type = NULL;

	if (!goodPRL (p)) return;
	CPofPRL (p, to);
	strcpy (b, MsgIDofPRL (p));
	if (!contact (to, I, author, i)) return;

	/* PROTOCOL-STUFF-LOCATION */
	O.putarg (Globals.PMSGtext [GET]);
	O.putarg (b);
	O.writeout (I.fd);

	if (I.getarg (b, 10) != GETARG_OK
	|| PMSGtype (b) != PNET_OK || I.getarg (b, 16) != GETARG_OK
	|| (len = ahtoi (b)) < 0 || I.getarg (b, 40) != GETARG_OK)
		goto ph_fail;

	if (b [0]) type = StrDup (b);

	if (I.getarg (b, 16) == GETARG_OK
	&& I.getarg (dateb, MAX_DATE) == GETARG_OK) {
		rep = ahtoi (b);
		date = StrDup (dateb);
	} else goto ph_fail;

	if (getcontent) {
		O.putarg (Globals.PMSGtext [GET]);
		O.writeout (I.fd);
		if (I.getarg (b, 16) == GETARG_OK && PMSGtype (b) == PNET_OK) {
			content = new char [len + 1];
			I.getdata (content, len);
			content [len] = 0;

			itsbinary = false;
			for (i = 0; i < (int) len; i++)
				if (content [i] < ' ' && content [i] != '\n'
				&& content [i] != '\r' && content [i] != '\t') {
					itsbinary = true;
					break;
				}

			if (!type) type = (itsbinary) ? unknown : textplain;

			crcok = true; if (crc)
				crcok = adler32 (1L, content, len) == crc;
		}
	} else {
		O.putarg (Globals.PMSGtext [PNET_OK]);
		O.writeout (I.fd);
	}
ph_fail:
	close (I.fd);
}

postnet_get::~postnet_get ()
{
	if (date) delete [] date;
	if (content) delete [] content;
	if (type) iStrDelete (type);
}
